"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var ava_1 = require("ava");
var graphql_tools_1 = require("graphql-tools");
var graphql_middleware_1 = require("graphql-middleware");
var graphql_upload_1 = require("graphql-upload");
var graphql_1 = require("graphql");
var index_1 = require("../index");
// Helpers
// Tests
ava_1.default('Finds Argument With Type', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var typeDefs, resolvers, middleware, schema, schemaWithMiddleware, query, res;
    var _this = this;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                t.plan(2);
                typeDefs = "\n    type Query {\n      test(string: String, boolean: Boolean!): String!\n    }\n  ";
                resolvers = {
                    Query: {
                        test: function (parent, args, ctx, infp) { return 'pass'; },
                    },
                };
                middleware = {
                    Query: {
                        test: function (resolve, parent, args, ctx, info) { return __awaiter(_this, void 0, void 0, function () {
                            var X;
                            return __generator(this, function (_a) {
                                X = index_1.findArgumentsOfType(graphql_1.GraphQLString, info);
                                t.is(X.length, 1);
                                return [2 /*return*/, resolve()];
                            });
                        }); },
                    },
                };
                schema = graphql_tools_1.makeExecutableSchema({ typeDefs: typeDefs, resolvers: resolvers });
                schemaWithMiddleware = graphql_middleware_1.applyMiddleware(schema, middleware);
                query = "\n    query {\n      test(string: \"trigger\", boolean: true)\n    }\n  ";
                return [4 /*yield*/, graphql_1.graphql(schema, query)];
            case 1:
                res = _a.sent();
                t.is(res.data.test, 'pass');
                return [2 /*return*/];
        }
    });
}); });
ava_1.default("Doesn't find Argument With Type", function (t) { return __awaiter(_this, void 0, void 0, function () {
    var typeDefs, resolvers, middleware, schema, schemaWithMiddleware, query, res;
    var _this = this;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                t.plan(2);
                typeDefs = "\n    type Query {\n      test(b1: Boolean!, b2: Boolean!): String!\n    }\n  ";
                resolvers = {
                    Query: {
                        test: function (parent, args, ctx, info) { return 'pass'; },
                    },
                };
                middleware = {
                    Query: {
                        test: function (resolve, parent, args, ctx, info) { return __awaiter(_this, void 0, void 0, function () {
                            var X;
                            return __generator(this, function (_a) {
                                X = index_1.findArgumentsOfType(graphql_1.GraphQLString, info);
                                t.is(X.length, 0);
                                return [2 /*return*/, resolve()];
                            });
                        }); },
                    },
                };
                schema = graphql_tools_1.makeExecutableSchema({ typeDefs: typeDefs, resolvers: resolvers });
                schemaWithMiddleware = graphql_middleware_1.applyMiddleware(schema, middleware);
                query = "\n    query {\n      test(b1: false, b2: true)\n    }\n  ";
                return [4 /*yield*/, graphql_1.graphql(schema, query)];
            case 1:
                res = _a.sent();
                t.is(res.data.test, 'pass');
                return [2 /*return*/];
        }
    });
}); });
ava_1.default('Finds Argument With List Type', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var typeDefs, resolvers, middleware, schema, schemaWithMiddleware, query, res;
    var _this = this;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                t.plan(2);
                typeDefs = "\n    type Query {\n      test(strings: [String]!, boolean: Boolean!): String!\n    }\n  ";
                resolvers = {
                    Query: {
                        test: function (parent, args, ctx, infp) { return 'pass'; },
                    },
                };
                middleware = {
                    Query: {
                        test: function (resolve, parent, args, ctx, info) { return __awaiter(_this, void 0, void 0, function () {
                            var X;
                            return __generator(this, function (_a) {
                                X = index_1.findArgumentsOfType(graphql_1.GraphQLString, info);
                                t.is(X.length, 1);
                                return [2 /*return*/, resolve()];
                            });
                        }); },
                    },
                };
                schema = graphql_tools_1.makeExecutableSchema({ typeDefs: typeDefs, resolvers: resolvers });
                schemaWithMiddleware = graphql_middleware_1.applyMiddleware(schema, middleware);
                query = "\n    query {\n      test(strings: [\"trigger\"], boolean: true)\n    }\n  ";
                return [4 /*yield*/, graphql_1.graphql(schema, query)];
            case 1:
                res = _a.sent();
                t.is(res.data.test, 'pass');
                return [2 /*return*/];
        }
    });
}); });
ava_1.default('Values in processor match', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var typeDefs, resolvers, middleware, schema, schemaWithMiddleware, query, res;
    var _this = this;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                t.plan(2);
                typeDefs = "\n    type Query {\n      test(string: String!): String!\n    }\n  ";
                resolvers = {
                    Query: {
                        test: function (parent, args, ctx, infp) { return 'pass'; },
                    },
                };
                middleware = {
                    Query: {
                        test: function (resolve, parent, args, ctx, info) { return __awaiter(_this, void 0, void 0, function () {
                            var X;
                            return __generator(this, function (_a) {
                                X = index_1.findArgumentsOfType(graphql_1.GraphQLString, info);
                                t.is(index_1.getArgumentValue(args, X[0]), 'trigger');
                                return [2 /*return*/, resolve()];
                            });
                        }); },
                    },
                };
                schema = graphql_tools_1.makeExecutableSchema({ typeDefs: typeDefs, resolvers: resolvers });
                schemaWithMiddleware = graphql_middleware_1.applyMiddleware(schema, middleware);
                query = "\n    query {\n      test(string: \"trigger\")\n    }\n  ";
                return [4 /*yield*/, graphql_1.graphql(schema, query)];
            case 1:
                res = _a.sent();
                t.is(res.data.test, 'pass');
                return [2 /*return*/];
        }
    });
}); });
ava_1.default('Is GraphQLUpload type', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var typeDefs, resolvers, middleware, schema, schemaWithMiddleware, query, res;
    var _this = this;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                t.plan(2);
                typeDefs = "\n    scalar Upload\n\n    type Query {\n      test(upload: Upload): String!\n    }\n  ";
                resolvers = {
                    Query: {
                        test: function (parent, args, ctx, infp) { return 'pass'; },
                    },
                    Upload: graphql_upload_1.GraphQLUpload,
                };
                middleware = {
                    Query: {
                        test: function (resolve, parent, args, ctx, info) { return __awaiter(_this, void 0, void 0, function () {
                            var X;
                            return __generator(this, function (_a) {
                                X = index_1.findArgumentsOfType(graphql_upload_1.GraphQLUpload, info);
                                t.is(X[0].name, 'upload');
                                return [2 /*return*/, resolve()];
                            });
                        }); },
                    },
                };
                schema = graphql_tools_1.makeExecutableSchema({ typeDefs: typeDefs, resolvers: resolvers });
                schemaWithMiddleware = graphql_middleware_1.applyMiddleware(schema, middleware);
                query = "\n    query {\n      test\n    }\n  ";
                return [4 /*yield*/, graphql_1.graphql(schema, query)];
            case 1:
                res = _a.sent();
                t.is(res.data.test, 'pass');
                return [2 /*return*/];
        }
    });
}); });
ava_1.default('Is GraphQLUpload List type', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var typeDefs, resolvers, middleware, schema, schemaWithMiddleware, query, res;
    var _this = this;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                t.plan(2);
                typeDefs = "\n    scalar Upload\n\n    type Query {\n      test(upload: [Upload]): String!\n    }\n  ";
                resolvers = {
                    Query: {
                        test: function (parent, args, ctx, infp) { return 'pass'; },
                    },
                    Upload: graphql_upload_1.GraphQLUpload,
                };
                middleware = {
                    Query: {
                        test: function (resolve, parent, args, ctx, info) { return __awaiter(_this, void 0, void 0, function () {
                            var X;
                            return __generator(this, function (_a) {
                                X = index_1.findArgumentsOfType(graphql_upload_1.GraphQLUpload, info);
                                t.is(X[0].name, 'upload');
                                return [2 /*return*/, resolve()];
                            });
                        }); },
                    },
                };
                schema = graphql_tools_1.makeExecutableSchema({ typeDefs: typeDefs, resolvers: resolvers });
                schemaWithMiddleware = graphql_middleware_1.applyMiddleware(schema, middleware);
                query = "\n    query {\n      test\n    }\n  ";
                return [4 /*yield*/, graphql_1.graphql(schema, query)];
            case 1:
                res = _a.sent();
                t.is(res.data.test, 'pass');
                return [2 /*return*/];
        }
    });
}); });
ava_1.default('Identifies GraphQLUpload type correctly', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var typeDefs, resolvers, middleware, schema, schemaWithMiddleware, query, res;
    var _this = this;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                t.plan(3);
                typeDefs = "\n    scalar Upload\n\n    type Query {\n      test(pass: [Upload]): String!\n    }\n  ";
                resolvers = {
                    Query: {
                        test: function (parent, args, ctx, infp) { return 'pass'; },
                    },
                    Upload: graphql_upload_1.GraphQLUpload,
                };
                middleware = {
                    Query: {
                        test: function (resolve, parent, args, ctx, info) { return __awaiter(_this, void 0, void 0, function () {
                            var res;
                            return __generator(this, function (_a) {
                                res = index_1.findArgumentsOfType(graphql_upload_1.GraphQLUpload, info);
                                t.is(res[0].name, 'pass');
                                t.is(index_1.getArgumentValue(args, res[0]), undefined);
                                return [2 /*return*/, resolve()];
                            });
                        }); },
                    },
                };
                schema = graphql_tools_1.makeExecutableSchema({ typeDefs: typeDefs, resolvers: resolvers });
                schemaWithMiddleware = graphql_middleware_1.applyMiddleware(schema, middleware);
                query = "\n    query {\n      test\n    }\n  ";
                return [4 /*yield*/, graphql_1.graphql(schema, query)];
            case 1:
                res = _a.sent();
                t.is(res.data.test, 'pass');
                return [2 /*return*/];
        }
    });
}); });
ava_1.default('Processor handles single file correctly', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var uploadHandler, args, res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                uploadHandler = function (_a) {
                    var stream = _a.stream, filename = _a.filename, mimetype = _a.mimetype, encoding = _a.encoding;
                    return new Promise(function (resolve) {
                        return setTimeout(function () { return resolve("" + stream + filename + mimetype + encoding); }, 10);
                    });
                };
                args = {
                    test: new Promise(function (resolve) {
                        return resolve({ stream: 's', filename: 'f', mimetype: 'm', encoding: 'e' });
                    }),
                };
                return [4 /*yield*/, index_1.makeArgumentTransform(uploadHandler, {}, args, {}, {})({
                        name: 'test',
                        type: graphql_upload_1.GraphQLUpload,
                    })];
            case 1:
                res = _a.sent();
                t.deepEqual(res, { test: 'sfme' });
                return [2 /*return*/];
        }
    });
}); });
ava_1.default('Processor handles multiple files correctly', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var uploadHandler, file, args, res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                uploadHandler = function (_a) {
                    var stream = _a.stream, filename = _a.filename, mimetype = _a.mimetype, encoding = _a.encoding;
                    return new Promise(function (resolve) {
                        return setTimeout(function () { return resolve("" + stream + filename + mimetype + encoding); }, 10);
                    });
                };
                file = function (x) {
                    return new Promise(function (resolve) {
                        return resolve({
                            stream: "s" + x,
                            filename: "f" + x,
                            mimetype: "m" + x,
                            encoding: "e" + x,
                        });
                    });
                };
                args = {
                    test: [file(1), file(2)],
                };
                return [4 /*yield*/, index_1.makeArgumentTransform(uploadHandler, {}, args, {}, {})({
                        name: 'test',
                        type: new graphql_1.GraphQLList(graphql_upload_1.GraphQLUpload),
                    })];
            case 1:
                res = _a.sent();
                t.deepEqual(res, { test: ['s1f1m1e1', 's2f2m2e2'] });
                return [2 /*return*/];
        }
    });
}); });
ava_1.default('Processor handles empty files correctly', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var uploadHandler, file, args, res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                uploadHandler = function (_a) {
                    var stream = _a.stream, filename = _a.filename, mimetype = _a.mimetype, encoding = _a.encoding;
                    return new Promise(function (resolve) {
                        return setTimeout(function () { return resolve("" + stream + filename + mimetype + encoding); }, 10);
                    });
                };
                file = function (x) {
                    return new Promise(function (resolve) {
                        return resolve({
                            stream: "s" + x,
                            filename: "f" + x,
                            mimetype: "m" + x,
                            encoding: "e" + x,
                        });
                    });
                };
                args = {
                    test: [file(1), null, undefined],
                };
                return [4 /*yield*/, index_1.makeArgumentTransform(uploadHandler, {}, args, {}, {})({
                        name: 'test',
                        type: new graphql_1.GraphQLList(graphql_upload_1.GraphQLUpload),
                    })];
            case 1:
                res = _a.sent();
                t.deepEqual(res, { test: ['s1f1m1e1'] });
                return [2 /*return*/];
        }
    });
}); });
ava_1.default('Processor handles no file correctly', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var uploadHandler, args, res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                uploadHandler = function (_a) {
                    var stream = _a.stream, filename = _a.filename, mimetype = _a.mimetype, encoding = _a.encoding;
                    return new Promise(function (resolve) {
                        return setTimeout(function () { return resolve("" + stream + filename + mimetype + encoding); }, 10);
                    });
                };
                args = {
                    test: null,
                };
                return [4 /*yield*/, index_1.makeArgumentTransform(uploadHandler, {}, args, {}, {})({
                        name: 'test',
                        type: graphql_1.GraphQLString,
                    })];
            case 1:
                res = _a.sent();
                t.is(res, null);
                return [2 /*return*/];
        }
    });
}); });
ava_1.default('processTypeArgs applies a transformation correctly', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var theValue, typeDefs, resolvers, middleware, schema, schemaWithMiddleware, query, res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                // write a schema, an arg transform, and a query
                t.plan(5);
                theValue = 'some-random-string';
                typeDefs = "\n    scalar Custom\n\n    type Query {\n      test(pass: Custom): [String]!\n    }\n  ";
                resolvers = {
                    Query: {
                        test: function (parent, args, ctx, infp) {
                            t.deepEqual(args, { pass: String('-' + theValue + '-').toUpperCase() });
                            return String(args.pass).split('-');
                        },
                    },
                    Custom: new graphql_1.GraphQLScalarType({
                        name: 'Custom',
                        serialize: function (x) { return x; },
                        parseValue: function (x) { return x; },
                        parseLiteral: function (x) {
                            t.is(x['value'], theValue);
                            return "-" + x['value'] + "-";
                        },
                    }),
                };
                middleware = {
                    Query: {
                        test: index_1.processTypeArgs({
                            type: 'Custom',
                            transform: function (x) {
                                t.is(x, '-' + theValue + '-');
                                return Promise.resolve(String(x).toUpperCase());
                            },
                        }),
                    },
                };
                schema = graphql_tools_1.makeExecutableSchema({ typeDefs: typeDefs, resolvers: resolvers });
                schemaWithMiddleware = graphql_middleware_1.applyMiddleware(schema, middleware);
                query = "\n    query {\n      test(pass: \"" + theValue + "\")\n    }\n  ";
                return [4 /*yield*/, graphql_1.graphql(schema, query)];
            case 1:
                res = _a.sent();
                t.deepEqual(res.data.test, String('-' + theValue + '-')
                    .toUpperCase()
                    .split('-'));
                return [2 /*return*/];
        }
    });
}); });
//# sourceMappingURL=index.test.js.map